src/Entity/User.php
<?php

namespace App\Entity;

use ApiPlatform\Metadata\ApiFilter;
use ApiPlatform\Metadata\ApiResource;
use ApiPlatform\Metadata\GetCollection;
use ApiPlatform\Metadata\Patch;
use App\Api\Filters\UsernameFilter;
use App\Api\State\SearchBeneficiaryProvider;
use App\Api\State\UserPasswordProcessor;
use App\Entity\Attributes\AccessToken;
use App\Entity\Attributes\Adresse;
use App\Entity\Attributes\Centre;
use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\ReadableCollection;
use Doctrine\ORM\Event\PreUpdateEventArgs;
use Doctrine\ORM\Mapping as ORM;
use Erkens\Security\TwoFactorTextBundle\Model\TwoFactorTextInterface;
use MakinaCorpus\DbToolsBundle\Attribute\Anonymize;
use Ramsey\Uuid\Uuid;
use Ramsey\Uuid\UuidInterface;
use Scheb\TwoFactorBundle\Model\Email\TwoFactorInterface;
use Symfony\Component\Serializer\Annotation\Groups;
use Symfony\Component\String\Slugger\AsciiSlugger;

#[ORM\Entity(repositoryClass: UserRepository::class)]
#[ApiFilter(UsernameFilter::class, properties: ['username' => 'exact'])]
#[ApiResource(
    operations: [
        new GetCollection(security: "is_granted('ROLE_OAUTH2_USERS') or is_granted('ROLE_USER')", provider: SearchBeneficiaryProvider::class),
        new Patch(security: "is_granted('UPDATE', object)", processor: UserPasswordProcessor::class),
    ],
    normalizationContext: ['groups' => ['v3:user:read']],
    denormalizationContext: ['groups' => ['v3:user:write']],
)]
#[Anonymize('reconnect.user_filter')]
class User extends BaseUser implements \JsonSerializable, TwoFactorInterface, TwoFactorTextInterface
{
    private const string BASE_USERNAME_REGEXP = '/^[a-z\-]+\.[a-z\-]+(\.[0-3][0-9]\/[0-1][0-9]\/[1-2][0-9]{3})?$/';
    public const string USER_TYPE_BENEFICIAIRE = 'ROLE_BENEFICIAIRE';
    public const string USER_TYPE_MEMBRE = 'ROLE_MEMBRE';
    public const string USER_TYPE_GESTIONNAIRE = 'ROLE_GESTIONNAIRE';
    public const string USER_TYPE_ASSOCIATION = 'ROLE_ASSOCIATION';
    public const string USER_TYPE_ADMINISTRATEUR = 'ROLE_ADMIN';
    public const string USER_TYPE_SUPER_ADMIN = 'ROLE_SUPER_ADMIN';
    public const int USER_PASSWORD_LENGTH = 9;

    public const array ADMIN_TYPES = [
        self::USER_TYPE_ADMINISTRATEUR => self::USER_TYPE_ADMINISTRATEUR,
        self::USER_TYPE_SUPER_ADMIN => self::USER_TYPE_SUPER_ADMIN,
    ];
    public const string DEFAULT_LANGUAGE = 'fr';
    public const array LANGUAGES = [
        'ar' => 'ar',
        'de' => 'de',
        'en' => 'en',
        'es' => 'es',
        'fr' => 'fr',
        'gb' => 'en',
        'it' => 'it',
        'ps' => 'ps',
        'prs' => 'prs',
        'ru' => 'ru',
    ];

    public const array USER_TYPES = [
        self::USER_TYPE_BENEFICIAIRE => 'beneficiaire',
        self::USER_TYPE_MEMBRE => 'membre',
        self::USER_TYPE_GESTIONNAIRE => 'gestionnaire',
        self::USER_TYPE_ASSOCIATION => 'association',
        self::USER_TYPE_ADMINISTRATEUR => 'administrateur',
    ];

    public const string MFA_METHOD_SMS = 'sms';
    public const string MFA_METHOD_EMAIL = 'email';
    public const array MFA_METHODS = [
        self::MFA_METHOD_EMAIL,
        self::MFA_METHOD_SMS,
    ];
    public const int MFA_MAX_SEND_CODE_COUNT = 3;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    #[Anonymize('md5')]
    protected $username = '';

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read', 'v3:beneficiary:write'])]
    #[Anonymize('email', options: ['domain' => 'yopmail.com'])]
    protected $email;

    /**
     * @var \DateTime|null
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    protected $lastLogin;

    /**
     * @var int
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    protected $id;

    /**
     * @var \DateTime
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private $createdAt;

    /**
     * @var \DateTime
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private $updatedAt;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read', 'v3:beneficiary:write'])]
    #[Anonymize('fr-fr.firstname')]
    private $prenom;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read', 'v3:beneficiary:write'])]
    #[Anonymize('fr-fr.lastname')]
    private $nom;

    #[Groups(['read', 'user:read', 'v3:user:read', 'v3:beneficiary:write'])]
    #[Anonymize('date', options: ['min' => 'now -70 years', 'max' => 'now -15 years'])]
    private ?\DateTime $birthDate = null;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read', 'v3:beneficiary:write'])]
    #[Anonymize('fr-fr.phone')]
    private $telephone;

    /** @var string */
    private $telephoneFixe;

    /**
     * @var bool
     */
    #[Groups(['read', 'user:read'])]
    private $bActif = false;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private $typeUser;

    /** @var string */
    private $privateKey = '';
    /**
     * @var string
     */
    #[Groups(['read', 'user:read'])]
    private $lastIp;

    private ?string $lastLang = null;

    /** @var Administrateur */
    private $subjectAdministrateur;

    /** @var Beneficiaire */
    private $subjectBeneficiaire;

    /** @var Membre */
    private $subjectMembre;

    /** @var Association */
    private $subjectAssociation;

    /** @var Gestionnaire */
    private $subjectGestionnaire;

    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private ?Adresse $adresse = null;

    /**
     * @var bool
     */
    private $firstVisit = true;

    /**
     * @var bool
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private $bFirstMobileConnexion = false;

    /**
     * @var Collection
     */
    private $refreshTokens;

    /**
     * @var Collection
     */
    private $accessTokens;

    /**
     * @var \DateTime
     */
    #[Groups(['read', 'user:read', 'v3:user:read'])]
    private $derniereConnexionAt;

    /**
     * @var string
     */
    #[Groups(['read', 'user:read'])]
    private $avatar;

    /**
     * @var bool
     */
    private $test = false;

    /**
     * @var string
     */
    private $autoLoginToken;

    /**
     * @var \DateTime
     */
    private $autoLoginTokenDeliveredAt;
    private $creators;
    private bool $canada = false;
    private ?string $fcnToken = null;

    #[Anonymize('md5')]
    private ?string $oldUsername = null;
    /** @var ?Collection<int, SharedDocument> */
    private ?Collection $sharedDocuments = null;

    private ?\DateTimeImmutable $cgsAcceptedAt = null;
    private ?\DateTimeImmutable $personalAccountDataRequestedAt = null;

    private bool $hasPasswordWithLatestPolicy = false;

    private ?string $authCode = null;
    private ?bool $mfaEnabled = null;
    private ?bool $mfaPending = null;    // This is only used when login from API
    private ?bool $mfaValid = null;    // This is only used when login from API
    private string $mfaMethod = self::MFA_METHOD_EMAIL;
    private ?int $mfaRetryCount = 0;
    private ?\DateTimeInterface $mfaCodeGeneratedAt = null;

    /** @var string[] */
    private array $relaysIds = [];
    private ?string $externalRelayId = null;
    private ?string $externalProId = null;

    public function __construct()
    {
        parent::__construct();
        $this->refreshTokens = new ArrayCollection();
        $this->creators = new ArrayCollection();
    }

    public static function createPro(): self
    {
        $user = new self();
        (new Membre())->setUser($user);

        return $user;
    }

    #[\Override]
    public function getUserIdentifier(): string
    {
        return $this->username;
    }

    /**
     * @return string
     */
    public function getPrenom()
    {
        return $this->prenom;
    }

    /**
     * @param string $prenom
     *
     * @return User
     */
    public function setPrenom($prenom)
    {
        $this->prenom = $prenom;

        return $this;
    }

    /**
     * @return string
     */
    public function getNom()
    {
        return $this->nom;
    }

    /**
     * @param string $nom
     *
     * @return User
     */
    public function setNom($nom)
    {
        $this->nom = $nom;

        return $this;
    }

    public function setEmail($email)
    {
        $this->email = $email;
        $this->emailCanonical = $email;

        return $this;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function getBirthDate(): ?\DateTime
    {
        return $this->birthDate;
    }

    public function setBirthDate(?\DateTime $birthDate): self
    {
        $this->birthDate = $birthDate;

        return $this;
    }

    public function getFullName(): string
    {
        return $this->prenom.' '.$this->nom;
    }

    /**
     * Get telephone.
     *
     * @return ?string
     */
    public function getTelephone()
    {
        return $this->telephone;
    }

    /**
     * @param string $telephone
     *
     * @return User
     */
    public function setTelephone($telephone = null)
    {
        $this->telephone = $telephone;

        return $this;
    }

    /**
     * @return string
     */
    public function getTelephoneFixe()
    {
        return $this->telephoneFixe;
    }

    /**
     * @param string $telephoneFixe
     *
     * @return User
     */
    public function setTelephoneFixe($telephoneFixe)
    {
        $this->telephoneFixe = $telephoneFixe;

        return $this;
    }

    /**
     * @return bool
     */
    public function getBActif()
    {
        return $this->bActif;
    }

    /**
     * @param bool $bActif
     *
     * @return User
     */
    public function setBActif($bActif)
    {
        $this->bActif = $bActif;

        return $this;
    }

    /**
     * @return string
     */

templates/v2/pro/create/_search_results_card.html.twig
{% extends 'v2/common/_card.html.twig' %}

{% set title='results'|trans %}

{% block customContent %}
    {% if pros|length == 0 %}
        {% include 'v2/common/_no_results.html.twig' %}
    {% else %}
        <ul class="list-group mb-3">
            {% for pro in pros %}
                {% set user = pro.user %}
                <li class="list-group-item d-flex justify-content-between align-items-center text-primary">
                    <div>
                        <span>{{ user.fullName }}</span>
                        <span class="text-grey">{{ user.email ? '('~user.email~')' }}</span>
                    </div>
                    <a
                            class="btn btn-sm btn-blue text-white"
                            href="{{ path('invite_user', {id: user.id}) }}"
                    >{{ 'add'|trans }}</a>
                </li>
            {% endfor %}
        </ul>
        {{ knp_pagination_render(pros) }}
    {% endif %}
{% endblock %}

templates/v2/pro/create/create.html.twig
{% extends 'v2/standard_layout.html.twig' %}
{% block metaTitle %}{{ 'add_new_user'|trans }}{% endblock %}

{% block delimiter %}{% endblock %}

{% block content %}
    <div class="row">
        <div class="col-12 mt-2">
            {{ include('v2/common/_card_with_form.html.twig', {
                title: 'create_account'|trans,
                form,
                backPath: path('create_pro_home'),
            }) }}
        </div>
    </div>
{% endblock %}

templates/v2/pro/create/index.html.twig
{% extends 'v2/standard_layout.html.twig' %}
{% block metaTitle %}{{ 'add_user'|trans }}{% endblock %}

{% block delimiter %}{% endblock %}

{% block content %}
    <div class="row">
        <div class="col-12 col-md-6 mt-2">
            {{ include('v2/common/_card.html.twig', {
                title: 'user_has_account'|trans,
                iconName: 'magnifying-glass',
                helpText: 'search_professional_help'|trans,
                buttonPath:  path('search_pro'),
                buttonText: 'search'|trans,
            }) }}
        </div>
        <div class="col-12 col-md-6 mt-2">
            {{ include('v2/common/_card.html.twig', {
                title: 'user_do_not_have_account'|trans,
                iconName: 'plus',
                helpText: 'create_professional_help'|trans,
                buttonPath:  path('create_pro'),
                buttonText: 'create_account'|trans,
            }) }}
        </div>
    </div>
{% endblock %}

templates/v2/pro/create/search.html.twig
{% extends 'v2/management_layout.html.twig' %}
{% block metaTitle %}{{ 'choose_user'|trans }}{% endblock %}
{% block subTitle %}{{ 'search_existing_user'|trans|upper }}{% endblock %}
{% block subTitleIconName %}user-plus{% endblock %}

{% block content %}
    <div class="row mt-5">
        <div class="col-12 col-md-4">
            {{ form_start(form, {
                attr: {class: 'display-required-labels'},
            }) }}
            {{ form_row(form.firstname) }}
            {{ form_row(form.lastname) }}
            <div class="mt-3">
                {{ include('v2/common/_button.html.twig', {
                    message: 'search'|trans,
                    fullWidth: true,
                }) }}
            </div>
            {{ form_end(form) }}
        </div>
        <div class="col-12 col-md-8">
            {{ include('v2/pro/create/_search_results_card.html.twig', {pros}) }}
        </div>
    </div>
{% endblock %}